/*sampler_linux.h */
/* sampler_linux.h,v 1.1.1.1 2005/11/03 19:58:58 xusf Exp */
/***********************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of
* California, as Operator of Los Alamos National Laboratory, and
* Berliner Elektronenspeicherring-Gesellschaft m.b.H. (BESSY).
* asynDriver is distributed subject to a Software License Agreement
* found in file LICENSE that is included with this distribution.
***********************************************************************/
/*
 * Author: Shifu Xu
 * Date:   03NOV2005
 */

#ifndef SAMPLER_LINUX_H
#define SAMPLER_LINUX_H

#ifndef __KERNEL__
#include <signal.h>
#include <stdint.h>
#else
#include <linux/types.h>
#include <asm/siginfo.h>
#endif

struct ts_kernel
{
    struct timeval interrupt_begin;
    struct timeval top_half;
    struct timeval bottom_half;
    struct timeval context_begin;
};

typedef struct data_from_user
{
    int vector;
    int level;
    struct sigevent signalEvent;
} data_from_user;

#define SAMPLER_MAGIC  0xbc
#define SAMPLER_IOCTL_GETTS                  _IOR(SAMPLER_MAGIC, 1, struct ts_kernel)
#define SAMPLER_IOCTL_GENERATE_VME_INTERRUPT _IOR(SAMPLER_MAGIC, 2, void *)
#define SAMPLER_IOCTL_ATTACH  _IOR(SAMPLER_MAGIC, 3, struct data_from_user)
#define SAMPLER_IOCTL_USEUSERLEVELINTERRUPT _IOR(SAMPLER_MAGIC, 4, int)

#endif
